{This program is an example of using the Windows Clipboard (/x0 option)
 for gathering and copying information; it works just like TEST_ACD.PAS}

{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,R+,S+,V-,X-}
{$M 16384,0,50000} {NOTE: do NOT use maximum heap!}
uses Crt, Dos;

type
  str255 = string[255];

var
  acd_buffer_name: str255;

procedure PasteInClipBoard(var s: string);
var
  reg: registers;

begin
 with reg do
 begin
   ax:=$1700;
   intr($2f, reg);
   if ax<>$1700 then {we have support!}
   begin {open clipboard}
     ax:=$1701;
     intr($2f, reg);

     ax := $1702; (* empty !*)
     intr($2f, reg);

     ax := $1703;
     dx := 01; {text!}
     es := seg(s);
     bx := ofs(s)+1;
     si := 0;
     cx := byte(s[0]);
     intr($2f, reg); {written!}

     ax:=$1708;
     intr($2f, reg) ; {close clipboard}

   end;
 end;

end;

procedure CopyFromClipBoard(var s: string);
var
  reg: registers;

begin
 with reg do
 begin
   ax:=$1700;
   intr($2f, reg);
   if ax<>$1700 then {we have support!}
   begin {open clipboard}
     ax:=$1701;
     intr($2f, reg);

     reg.ax := $1704;
     reg.dx := 1;
     intr($2f, reg);
     if reg.ax<255 then
     begin {What is in it for us??}
       s[0] := char(reg.ax);
       reg.ax := $1705;
       reg.dx := 1;
       reg.bx := ofs(s)+1;
       reg.es := seg(s);
       intr($2f, reg);
     end
     else
       s := '';

     ax:=$1708;
     intr($2f, reg) ; {close clipboard}

   end;
 end;

end;


procedure call_acd(s1, s2: str255);
begin
  {in C: acd_buffer_name = \15+'ACD /w10'+\0}
  acd_buffer_name := 'ACD '+s2;
  pasteinclipboard(acd_buffer_name);
  exec(fsearch('acd.exe','.;'+getenv('PATH')),'/x0 /r1 *'+s1);
  copyfromclipboard(acd_buffer_name);
  if acd_buffer_name[1]+acd_buffer_name[2]+acd_buffer_name[3]='///' then
  begin
    writeln('Failed: ',acd_buffer_name);
  end
  else
    writeln('CHOSEN path = ',acd_buffer_name);
  writeln;
end;

begin
  ClrScr;
  Writeln('We would like to see ALL directories (*), and also show these directories ');
  Writeln('at the top of our screen (/t), with only 10 directories at a time (/w10)');
  writeln('ESC will cause a "FAILED", selection will return a PATH');
  writeln;
  call_acd('*','/w10/t');
  writeln;
  writeln('Now we would like to see all directories at the bottom of our screen (/b), ');
  writeln('in reverse colors (/reverse), and with only 6 directories at a time (/w6)');
  writeln;
  call_acd('* /reverse ','/w06/b');
  writeln;
  writeln('Now we would like to see only those dirs starting with an "A" (a*),');
  writeln('at the bottom of our screen (/b), in the non-graphical presentation (/g0)');
  writeln('in normal colors, and with only 2 directories at a time (/w2)');
  writeln;
  call_acd('a* /g0','/w02/b');
  writeln;
  writeln('Now we would like to see in the non-graphical presentation (/g0) ');
  writeln('all directories in the center of the screen (/c), in reverse colors (/reverse)');
  writeln('and with only 4 directories at a time (/w4)');
  writeln;
  call_acd('* /reverse /g0','/w04/c');
  writeln;
end.
